<?php
namespace TecFood\Services;

use Doctrine\DBAL\Connection;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\SMTP;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DependencyInjection\InstanceManager;
use Zeedhi\Framework\Util\QuerySelector;

chdir(__DIR__);

/** @var \Zeedhi\Framework\DependencyInjection\InstanceManager $instanceManager */
require_once '../bootstrap.php';
// $sincronizacao = $instanceManager->getService('userService');
$connection = InstanceManager::getInstance()->getService('entityManager')->getConnection();

$caminho = '../../modules/teknisa/coz/datasources';
$directories = glob($caminho . '/*.json');

foreach ($directories as $directory) {
    $dataSourceName = str_replace('.json', '', explode('/', $directory)[6]);
    $dataSource = file_get_contents($directory);
    $json = json_decode($dataSource, true);
    $sql = $json[$dataSourceName]["query"];
    if (array_key_exists('query_pdo_pgsql', $json) === false) {
        $json['query_pdo_pgsql'] = $sql; 
        try {
            file_put_contents($directory, json_encode($json));
        } catch (\Exception $e) {
            echo $e->getMessage();
        }
    }
    
    $a = preg_replace("/(:\w+)/", "null", $sql);
    $arrayQueries = array (
        'default'   => '',
        'pdo_pgsql' => $a,
    );

    try {
        $query = QuerySelector::getQueryByDriver($connection, $arrayQueries);
        $result = $connection->fetchAll($a, []);
    } catch (\Exception $e) {
        echo $e->getMessage(); 
    }
}