<?php
namespace Teknisa\COZ\Services;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Teknisa\COZ\Services\ControllerWrapper;
use Teknisa\COZ\Controllers\Lista;
use Teknisa\Libs\Util\NewCode as NovoCodigo;

class Pla10500Repository {

    protected $connection;
    protected $novoCodigo;
    protected $lista;
    protected $consplanGeral;
    protected $geraPlanProducao;
    protected $pedidosProducao;
    protected $proceLiberaProducao;
    public    $nrconsplan;
    protected $entityManager;
    public    $environment;

    public function __construct(
        $connection, NovoCodigo $novoCodigo, Lista $lista,
        StoredProcedure $consplanGeral, StoredProcedure $geraPlanProducao,
        StoredProcedure $alteraQtdeProdacabado,
        StoredProcedure $pedidosProducao,
        StoredProcedure $proceLiberaProducao,
        $entityManager, $environment){
        $this->connection = $connection;
        $this->novoCodigo = $novoCodigo;
        $this->lista = $lista;
        $this->consplanGeral = $consplanGeral;
        $this->geraPlanProducao = $geraPlanProducao;
        $this->alteraQtdeProdacabado = $alteraQtdeProdacabado;
        $this->pedidosProducao = $pedidosProducao;
        $this->proceLiberaProducao = $proceLiberaProducao;
        $this->entityManager = $entityManager;
        $this->environment = $environment;
    }

    public function consplanGeral($param, $idprodutos = 'CXX', $idarredond = 'N'){
        date_default_timezone_set("America/Sao_Paulo");

        $nrlista = $this->montaListaFiliServ($param['NRORG'], $param['SERVICOFILIAL']);

        $dtinicial = $param['DTCARDAINI'];
        $dtfinal = $param['DTCARDAFIN'];
//        $dtfinal = $param['DTCARDAFIN_FILTRO'];
//        $idprodutos = 'CFP';
        $idseprato = 'P';
        $peacrescimo = 0;
        $cdprodutoini = '0';
        $cdprodutofin = 'ZZZZZZZZZZ';
        $cdoperador = $param['CDOPERADOR'];
        $nrconsplanth = 'GERANOVCOD';

// var_dump("$nrlista, $dtinicial, $dtfinal, $idseprato, $peacrescimo, $cdprodutoini, $cdprodutofin, $cdoperador, $nrconsplanth");die;
        $this->consplanGeral->addParam(
            new Param ('P_NRLISTA', Param::PARAM_INPUT, $nrlista, Param::PARAM_TYPE_STR)
        );
        $this->consplanGeral->addParam(
            new Param ('P_DTINICIAL', Param::PARAM_INPUT, $dtinicial, Param::PARAM_TYPE_STR)
        );
        $this->consplanGeral->addParam(
            new Param ('P_DTFINAL', Param::PARAM_INPUT, $dtfinal, Param::PARAM_TYPE_STR)
        );
        $this->consplanGeral->addParam(
            new Param ('P_IDPRODUTOS', Param::PARAM_INPUT, $idprodutos, Param::PARAM_TYPE_STR)
        );
        $this->consplanGeral->addParam(
            new Param ('P_IDSEPPRATO', Param::PARAM_INPUT, $idseprato, Param::PARAM_TYPE_STR)
        );
        $this->consplanGeral->addParam(
            new Param ('P_PEACRESCIMO', Param::PARAM_INPUT, $peacrescimo, Param::PARAM_TYPE_STR)
        );
        $this->consplanGeral->addParam(
            new Param ('P_IDARREDOND', Param::PARAM_INPUT, $idarredond, Param::PARAM_TYPE_STR)
        );
        $this->consplanGeral->addParam(
            new Param ('P_CDPRODUTOINI', Param::PARAM_INPUT, $cdprodutoini, Param::PARAM_TYPE_STR)
        );
        $this->consplanGeral->addParam(
            new Param ('P_CDPRODUTOFIN', Param::PARAM_INPUT, $cdprodutofin, Param::PARAM_TYPE_STR)
        );
        $this->consplanGeral->addParam(
            new Param ('P_CDOPERADOR', Param::PARAM_INPUT, $cdoperador, Param::PARAM_TYPE_STR)
        );
        $this->consplanGeral->addParam(
            new Param ('P_NRCONSPLANTH', Param::PARAM_INPUT, $nrconsplanth, Param::PARAM_TYPE_STR)
        );
        $this->consplanGeral->addParam(
            new Param ('P_NRCONSPLAN', Param::PARAM_OUTPUT, NULL, Param::PARAM_TYPE_STR, 400)
        );

        return $this->consplanGeral->execute();
    }

    /**
     * @param $reset utilizado para recriar a instancia da procedure
     *      utilizando quando ao criar um PP encontra um insumo sem qtd.
     * 
    */
    public function geraPlanProducao($param, $operacao, $reset = false){
        date_default_timezone_set("America/Sao_Paulo");
        
        $nrorg = $param['NRORG'];
        $cdoperador = $param['CDOPERADOR'];
        
        if(isset($param['IDOBRIGINFOQTD']))$idobriginfoqtd = $param['IDOBRIGINFOQTD'] ;
        else $idobriginfoqtd = 'N' ;
        
        $nrplanprod = $param['NRPLANPROD'];
        $cdfilicent = $param['CDCENTRAL'];
        $dtproducao = $param['DTPRODUCAO'];
        $dtinicard = $param['DTCARDAINI'];
        $dtfincard = $param['DTCARDAFIN'];
        $dtfincard_filtro = $param['DTCARDAFIN_FILTRO'];

        if($operacao === 'G') {
            $cookchill = $param['COOKCHILL'];
            $estado = $param['ESTADO'];
        } else {
            $cookchill = null;
            $estado = null;
        }

        $tipoprat = $operacao === 'G'? $param['LISTATIPOPRAT'] : null;
        $setor = $operacao === 'G'? ($param['T_NMSETORCOZ'] === 'S' ? 'A' : $param['LISTASETORCOZ']) : null;

        if (\Zeedhi\Framework\Util\Functions::arrayKeyExists('SERVICOFILIAL', $param))
            $nrlista = $this->montaListaFiliServ($param['NRORG'], $param['SERVICOFILIAL']);
        else $nrlista = null;
        
        if ($reset) $this->geraPlanProducao = new StoredProcedure($this->connection,'GERA_PLAN_PRODUCAO');

        $this->geraPlanProducao->addParam(
            new Param ('P_NRPLANPROD', Param::PARAM_INPUT, $nrplanprod, Param::PARAM_TYPE_STR)
        );
        $this->geraPlanProducao->addParam(
            new Param ('P_OPERACAO', Param::PARAM_INPUT, $operacao, Param::PARAM_TYPE_STR)
        );
        $this->geraPlanProducao->addParam(
            new Param ('P_CDFILCENT', Param::PARAM_INPUT, $cdfilicent, Param::PARAM_TYPE_STR)
        );
        $this->geraPlanProducao->addParam(
            new Param ('P_DTPRODUCAO', Param::PARAM_INPUT, $dtproducao, Param::PARAM_TYPE_STR)
        );
        $this->geraPlanProducao->addParam(
            new Param ('P_DTINICARD', Param::PARAM_INPUT, $dtinicard, Param::PARAM_TYPE_STR)
        );
        $this->geraPlanProducao->addParam(
            new Param ('P_DTFINCARD', Param::PARAM_INPUT, $dtfincard_filtro, Param::PARAM_TYPE_STR)
        );
        $this->geraPlanProducao->addParam(
            new Param ('P_TIPOPRAT', Param::PARAM_INPUT, $tipoprat, Param::PARAM_TYPE_STR)
        );
        $this->geraPlanProducao->addParam(
            new Param ('P_SETOR', Param::PARAM_INPUT, $setor, Param::PARAM_TYPE_STR)
        );
        $this->geraPlanProducao->addParam(
            new Param ('P_CDOPERADOR', Param::PARAM_INPUT, $cdoperador, Param::PARAM_TYPE_STR)
        );
        $this->geraPlanProducao->addParam(
            new Param ('P_NRORG', Param::PARAM_INPUT, $nrorg, Param::PARAM_TYPE_STR)
        );
        $this->geraPlanProducao->addParam(
            new Param ('P_COOKCHILL', Param::PARAM_INPUT, $cookchill, Param::PARAM_TYPE_STR)
        );
        $this->geraPlanProducao->addParam(
            new Param ('P_ESTADO', Param::PARAM_INPUT, $estado, Param::PARAM_TYPE_STR)
        );

        $this->geraPlanProducao->addParam(
            new Param ('P_DTFINLIMITE', Param::PARAM_INPUT, $dtfincard, Param::PARAM_TYPE_STR)
        );
        $this->geraPlanProducao->addParam(
            new Param ('P_LISTAFILSERV', Param::PARAM_INPUT, $nrlista, Param::PARAM_TYPE_STR)
        );

        $this->geraPlanProducao->addParam(
            new Param ('P_RETORNO', Param::PARAM_OUTPUT, NULL, Param::PARAM_TYPE_STR, 400)
        );
        
        return $this->geraPlanProducao->execute();
    }

    public function montaListaFiliServ($nrorg, $filiaisServ){
        if (is_array($filiaisServ)) {
            $nrlistaFiliServ = $this->novoCodigo->getCodeByTableName(
                "LISTA", $nrorg
            );
            
            foreach ($filiaisServ as $filialServ) {
                if (!(empty($filialServ['SERVICO']))) {
                    $filialServicoParametros = array(
                        "NRORG" => $nrorg, "NRLISTA" => $nrlistaFiliServ,
                        "CDLISTA" => $filialServ['SERVICO']
                    );
                    $this->saveLista($filialServicoParametros);
                }
            }
        } else {
            $nrlistaFiliServ = 0;
        }
        return $nrlistaFiliServ;
    }

    public function saveLista($param){
        //$request = new DTO\Request\Row($param, "save", "/dummy", " ");
        //$response = new DTO\Response();
        //$this->lista->save($request, $response);

        $query = "INSERT INTO LISTA (NRORG, NRLISTA, CDLISTA) VALUES (:NRORG, :NRLISTA, :CDLISTA)";
        $this->connection->executeQuery($query, $param);
    }

    public function atualizaPlanprodfiliagrega($param){
        $query="UPDATE PLANPRODFILIAGREGA
                   SET VRTOTALPRODSERV = VRTOTALPRODSERV +(:VRTOTALRECEPRAT * :OPERACAO),
                       VRUNITPRODSERV = (VRTOTALPRODSERV + (:VRTOTALRECEPRAT * :OPERACAO))/(DECODE(NVL(QTCOMENSSERV, 0), 0, 1, QTCOMENSSERV)),
                       QTEXTRA = :QTEXTRA
                 WHERE (NRPLANPROD = :NRPLANPROD)
                   AND (CDPRODACABADO = :CDPRODACABADO)
                   AND (CDFILIAGREG = :CDFILIAGREG)
                   AND (CDSERVFILIAGREG = :CDSERVFILIAGREG)
                   AND (DTCONSUMO = :DTCONSUMO)
                   AND (IDCOOKCHILL = :IDCOOKCHILL)
                   AND (IDFINALIZACAO = :IDFINALIZACAO)
                   AND (IDTPPRODCHILL = :IDTPPRODCHILL)
                   AND (IDESTADO = :IDESTADO)
                   AND (NRSEQPRODACABADO = :NRSEQPRODACABADO)";
        foreach($param as $item) {
            $this->connection->executeQuery($query,
                array("VRTOTALRECEPRAT"=>$item['VRTOTALRECEPRAT'],"NRPLANPROD"=>$item['NRPLANPROD'],
                      "CDPRODACABADO"=>$item['CDPRODACABADO'],
//                      "CDPRODACABADO"=>$item['CDPRODUTO'],
                      "CDFILIAGREG"=>$item['CDFILIAGREG'],
                      "CDSERVFILIAGREG"=>$item['CDSERVFILIAGREG'], "DTCONSUMO"=>$item['DTCONSUMO'],
                      "IDCOOKCHILL"=>$item['IDCOOKCHILL'], "IDFINALIZACAO"=>$item['IDFINALIZACAO'],
                      "IDTPPRODCHILL"=>$item['IDTPPRODCHILL'], "IDESTADO"=>$item['IDESTADO'],
                      "NRSEQPRODACABADO"=>$item['NRSEQPRODACABADO'], "OPERACAO"=>$item['OPERACAO'],
                      "QTEXTRA"=> $item['QTEXTRA']
                )
            );
        }
    }

    public function atualizaPlanprodacabado($param){
        $query="UPDATE PLANPRODACABADO SET QTPRODACABADO = QTPRODACABADO + (:QTPRODRECEPRAT * :OPERACAO) WHERE (NRPLANPROD = :NRPLANPROD) AND (CDPRODACABADO = :CDPRODACABADO)";
        foreach($param as $item) {
            $this->connection->executeQuery($query,
                array("QTPRODRECEPRAT"=>$item['QTPRODRECEPRAT'], "NRPLANPROD"=>$item['NRPLANPROD'],
                      //"CDPRODACABADO"=>$item['CDPRODACABADO'],
                      "CDPRODACABADO"=>$item['CDPRODUTO'],
                      "OPERACAO"=>$item['OPERACAO']
                )
            );
        }
    }

    public function atualizaPaiProduzirProdacabado($param){
        $query="UPDATE PLANPRODACABADO SET IDPRODUZIR = :IDPRODUZIR WHERE CDPRODACABADO = :CDPRODACABADO AND NRPLANPROD = :NRPLANPROD AND NRORG = :NRORG AND IDCOOKCHILL = :IDCOOKCHILL AND IDFINALIZACAO = :IDFINALIZACAO AND IDTPPRODCHILL = :IDTPPRODCHILL AND IDESTADO = :IDESTADO AND NRSEQPRODACABADO = :NRSEQPRODACABADO";
        foreach($param as $item) {
            $this->connection->executeQuery($query,
                array("NRORG"=>$item['NRORG'], "NRPLANPROD"=>$item['NRPLANPROD'],
                      "CDPRODACABADO"=>$item['CDPRODUTO'],
                      "IDPRODUZIR"=>$item['PRODUZIR'],
                      "IDCOOKCHILL"=>$item['IDCOOKCHILL'], "IDFINALIZACAO"=>$item['IDFINALIZACAO'],
                      "IDTPPRODCHILL"=>$item['IDTPPRODCHILL'] ,"IDESTADO"=>$item['IDESTADO'],
                      "NRSEQPRODACABADO"=>$item['NRSEQPRODACABADO']
                )
            );
        }
    }

    public function atualizaFilhoProduzirProdacabado($param){
        $query="UPDATE PLANPRODFILIAGREGA SET IDPRODUZIR = :IDPRODUZIR WHERE NRPLANPROD = :NRPLANPROD AND CDPRODACABADO = :CDPRODACABADO AND NRORG = :NRORG AND IDCOOKCHILL = :IDCOOKCHILL AND IDFINALIZACAO = :IDFINALIZACAO AND IDTPPRODCHILL = :IDTPPRODCHILL AND IDESTADO = :IDESTADO AND NRSEQPRODACABADO = :NRSEQPRODACABADO";
        foreach($param as $item) {
            $this->connection->executeQuery($query,
                array("NRORG"=>$item['NRORG'], "NRPLANPROD"=>$item['NRPLANPROD'],
                      //"CDPRODACABADO"=>$item['CDPRODACABADO'],
                      "CDPRODACABADO"=>$item['CDPRODUTO'],
                      "IDPRODUZIR"=>$item['PRODUZIR'],
                      "IDCOOKCHILL"=>$item['IDCOOKCHILL'], "IDFINALIZACAO"=>$item['IDFINALIZACAO'],
                      "IDTPPRODCHILL"=>$item['IDTPPRODCHILL'] ,"IDESTADO"=>$item['IDESTADO'],"NRSEQPRODACABADO"=>$item['NRSEQPRODACABADO']
                )
            );
        }
    }

    public function atualizaFilhoProdFiliAgrega($param){
        $query="UPDATE PLANPRODFILIAGREGA SET IDPRODUZIR = :IDPRODUZIR WHERE NRPLANPROD = :NRPLANPROD AND CDPRODACABADO = :CDPRODACABADO AND CDFILIAGREG = :CDFILIAGREG AND CDSERVFILIAGREG = :CDSERVFILIAGREG AND DTCONSUMO = :DTCONSUMO AND NRORG = :NRORG AND IDCOOKCHILL = :IDCOOKCHILL AND IDFINALIZACAO = :IDFINALIZACAO AND IDTPPRODCHILL = :IDTPPRODCHILL AND IDESTADO = :IDESTADO AND NRSEQPRODACABADO = :NRSEQPRODACABADO";
        foreach($param as $item) {
            $this->connection->executeQuery($query,
                array("NRORG"=>$item['NRORG'], "NRPLANPROD"=>$item['NRPLANPROD'],
                      //"CDPRODACABADO"=>$item['CDPRODACABADO'],
                      "CDPRODACABADO"=>$item['CDPRODUTO'],
                      "CDFILIAGREG"=>$item['CDFILIAGREG'],
                      "CDSERVFILIAGREG"=>$item['CDSERVFILIAGREG'], "DTCONSUMO"=>$item['DTCONSUMO'],
                      "IDPRODUZIR"=>$item['PRODUZIR'],
                      "IDCOOKCHILL"=>$item['IDCOOKCHILL'], "IDFINALIZACAO"=>$item['IDFINALIZACAO'],
                      "IDTPPRODCHILL"=>$item['IDTPPRODCHILL'] ,"IDESTADO"=>$item['IDESTADO'],"NRSEQPRODACABADO"=>$item['NRSEQPRODACABADO']
                )
            );
        }
    }

    public function deletaConsplan(){
        $query="DELETE FROM CONSPLAN WHERE NRCONSPLAN = :NRCONSPLAN";
        $this->connection->executeQuery($query, array("NRCONSPLAN"=> $this->nrconsplan));
    }

    public function insereJustPlanProd($justificativa){
        $nrorg = $this->environment->getNrOrgTrab();
        $queryMax = "SELECT MAX(NRJUSTPLANPROD) NRJUSTPLANPROD FROM JUSTPLANPROD";
        $queryInsert = "INSERT INTO JUSTPLANPROD (NRJUSTPLANPROD, DSJUSTIFICA, NRORG) VALUES (:NRJUSTPLANPROD, :DSJUSTIFICA, :NRORG)";

        $valorMaximo = $this->connection->fetchAll($queryMax, array());
        $valorMaximo = $valorMaximo[0]['NRJUSTPLANPROD'];
        $valorMaximo++;

        $this->connection->executeQuery($queryInsert, array("NRJUSTPLANPROD"=> $valorMaximo, "DSJUSTIFICA"=> $justificativa, "NRORG"=> $nrorg));

        return $valorMaximo;
    }

    public function proceAlteraQtdeProdacabado($param){

        date_default_timezone_set("America/Sao_Paulo");

        $nrseqprodacabado = $param['NRSEQPRODACABADO'];
        $nrplanprod = $param['NRPLANPROD'];
        $cdprodacabado = $param['CDPRODUTO'];
        $idcookchill = $param['IDCOOKCHILL'];
        $idfinalizacao = $param['IDFINALIZACAO'];
        $idtpprodchill = $param['IDTPPRODCHILL'];
        $idestado = $param['IDESTADO'];
        $qtprodacabado = $param['QTPRODACABADO'];
        $qtaproduzir = $param['QTAPRODUZIR'];
        $nrjustificativa = $param['NRJUSTPLANPROD'];
        $nrorg = $param['NRORG'];
        $inseredif = $param['INSEREDIF'];
        $cdoperador = $param['CDOPERADOR'];
        $possuiaCapacidade = '';
        
        $this->alteraQtdeProdacabado->addParam(
            new Param ('P_NRSEQPRODACABADO', Param::PARAM_INPUT, $nrseqprodacabado, Param::PARAM_TYPE_STR)
        );
        $this->alteraQtdeProdacabado->addParam(
            new Param ('P_NRPLANPROD', Param::PARAM_INPUT, $nrplanprod, Param::PARAM_TYPE_STR)
        );
        $this->alteraQtdeProdacabado->addParam(
            new Param ('P_CDPRODACABADO', Param::PARAM_INPUT, $cdprodacabado, Param::PARAM_TYPE_STR)
        );
        $this->alteraQtdeProdacabado->addParam(
            new Param ('P_IDCOOKCHILL', Param::PARAM_INPUT, $idcookchill, Param::PARAM_TYPE_STR)
        );
        $this->alteraQtdeProdacabado->addParam(
            new Param ('P_IDFINALIZACAO', Param::PARAM_INPUT, $idfinalizacao, Param::PARAM_TYPE_STR)
        );
        $this->alteraQtdeProdacabado->addParam(
            new Param ('P_IDTPPRODCHILL', Param::PARAM_INPUT, $idtpprodchill, Param::PARAM_TYPE_STR)
        );
        $this->alteraQtdeProdacabado->addParam(
            new Param ('P_IDESTADO', Param::PARAM_INPUT, $idestado, Param::PARAM_TYPE_STR)
        );
        $this->alteraQtdeProdacabado->addParam(
            new Param ('P_QTPRODACABADO', Param::PARAM_INPUT, $qtprodacabado, Param::PARAM_TYPE_STR)
        );
        $this->alteraQtdeProdacabado->addParam(
            new Param ('P_QTAPRODUZIR', Param::PARAM_INPUT, $qtaproduzir, Param::PARAM_TYPE_STR)
        );
        $this->alteraQtdeProdacabado->addParam(
            new Param ('P_NRJUSTIFICATIVA', Param::PARAM_INPUT, $nrjustificativa, Param::PARAM_TYPE_STR)
        );
        $this->alteraQtdeProdacabado->addParam(
            new Param ('P_NRORG', Param::PARAM_INPUT, $nrorg, Param::PARAM_TYPE_STR)
        );
        $this->alteraQtdeProdacabado->addParam(
            new Param ('P_INSEREDIF', Param::PARAM_INPUT, $inseredif, Param::PARAM_TYPE_STR)
        );
        $this->alteraQtdeProdacabado->addParam(
            new Param ('P_CDOPERADOR', Param::PARAM_INPUT, $cdoperador, Param::PARAM_TYPE_STR)
        );
        
        $this->alteraQtdeProdacabado->addParam(
            new Param ('P_CAPACIDADE', Param::PARAM_OUTPUT, $possuiaCapacidade, Param::PARAM_TYPE_STR)
        );
        return $this->alteraQtdeProdacabado->execute();
    }

    public function atualizaLogMP(
        $nrorg, $codigo, $justificativa
    ){
        /** @var \Teknisa\Model\Planejamento\Entities\Logmatprima[] $log */
        $log = $this->entityManager->getRepository('\Teknisa\Model\Planejamento\Entities\Logmatprima')
            ->findBy(array('nrorg' => $nrorg, 'nrlogmatprima' => $codigo));

        $data = new \Zeedhi\Framework\ORM\DateTime();

        foreach ($log as $registro) {
            $registro->setDsjustificativa($justificativa);
            $registro->setDtultatu($data);
            $registro->setCdoperultatu($this->environment->getCdOperador());
            $this->entityManager->persist($registro);
        }

        $this->entityManager->flush();
        return true;
    }

    public function geraPedidoProducao($param){
        $nrorg = $param['NRORG'];
        $nrplanprod = $param['NRPLANPROD'];
        $nrlogmatprima = null;

        $this->pedidosProducao->addParam(
            new Param ('P_NRPLANPROD', Param::PARAM_INPUT, $nrplanprod, Param::PARAM_TYPE_STR)
        );
        $this->pedidosProducao->addParam(
            new Param ('P_NRORG', Param::PARAM_INPUT, $nrorg, Param::PARAM_TYPE_STR)
        );
        $this->pedidosProducao->addParam(
            new Param ('P_NRLOGMATPRIMA', Param::PARAM_OUTPUT, $nrlogmatprima, Param::PARAM_TYPE_STR, 10)
        );
        
        return $this->pedidosProducao->execute();

    }

    public function proceLiberaProducao($param){

        date_default_timezone_set("America/Sao_Paulo");
        $cdCentral = $param['CDCENTRAL'];
        $nrplanprod = $param['NRPLANPROD'];
        $dtProducao = $param['DTPRODUCAO'];
        $nrLista = $param['LISTA'];
        $validaEstq = $param['VALIDAESTOQUE'];
        $nrorg = $param['NRORG'];

        $this->proceLiberaProducao->addParam(
            new Param ('P_CDCENTRAL', Param::PARAM_INPUT, $cdCentral, Param::PARAM_TYPE_STR)
        );
        $this->proceLiberaProducao->addParam(
            new Param ('P_NRPLANPROD', Param::PARAM_INPUT, $nrplanprod, Param::PARAM_TYPE_STR)
        );
        $this->proceLiberaProducao->addParam(
            new Param ('P_DTPRODUCAO', Param::PARAM_INPUT, $dtProducao, Param::PARAM_TYPE_STR)
        );
        $this->proceLiberaProducao->addParam(
            new Param ('P_NRLISTA', Param::PARAM_INPUT, $nrLista, Param::PARAM_TYPE_STR)
        );
        $this->proceLiberaProducao->addParam(
            new Param ('P_VALIDA_ESTOQUE', Param::PARAM_INPUT, $validaEstq, Param::PARAM_TYPE_STR)
        );
        $this->proceLiberaProducao->addParam(
            new Param ('P_NRORG', Param::PARAM_INPUT, $nrorg, Param::PARAM_TYPE_STR)
        );
        $this->proceLiberaProducao->addParam(
            new Param ('P_RETORNO', Param::PARAM_OUTPUT, NULL, Param::PARAM_TYPE_STR, 400)
        );

        return $this->proceLiberaProducao->execute();
    }
}