<?php
namespace Teknisa\COZ\Services;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\COZ\Services\ControllerWrapper;

class Pla10510RemoteRepository{

    protected $grupfili;
    protected $filiaisagregadas;
    protected $grupserv;
    protected $servico_por_filiais;

    public function __construct($grupfili, $filiaisagregadas, $grupserv, $servico_por_filiais){
        $this->grupfili = $grupfili;
        $this->filiaisagregadas = $filiaisagregadas;
        $this->grupserv = $grupserv;
        $this->servico_por_filiais = $servico_por_filiais;
    }

    public function fetchGrupfili(){
        $emptyFilter = new FilterCriteria("", array());
        $rows = ControllerWrapper::fetchFromController($this->grupfili, $emptyFilter);
        return array_column($rows, "CDGRUPFILI");
    }

    public function fetchFiliaisagregadas($params){
        $filterCriteria = new FilterCriteria("filiaisagregadas", $params);
        $rows = ControllerWrapper::fetchFromController($this->filiaisagregadas, $filterCriteria);
        return array_column($rows, "CDFILIAL");
    }

    public function fetchGrupserv(){
        $emptyFilter = new FilterCriteria("", array());
        $rows = ControllerWrapper::fetchFromController($this->grupserv, $emptyFilter);
        return array_column($rows, "CDGRUPSERV");
    }

    public function fetchServicos($params){
        $filterCriteria = new FilterCriteria("servico_por_filiais", $params);
        $rows = ControllerWrapper::fetchFromController($this->servico_por_filiais, $filterCriteria);
        return array_map(function($item){
            return array(
                "CDFILIAL" => $item['CDFILIAL'],
                "CDGRUPSERV" => $item['CDGRUPSERV'],
                "NMSERVICO" => $item['NMSERVICO'],
                "CDSERVFILI" => $item['CDSERVFILI'],
                "SERVICO" => $item['CDFILIAL'].$item['CDSERVFILI']);
        }, $rows);
    }
}